1 GOTO 10
2 GOSUB 1890: LPRINT TAB(48);" Printed on ";TODAY$;" @";TIME$
3 LLIST
4 END
5 SAVE "C:\bas\lcdriver",A 'Save file on C drive in ASCII format
6 SAVE "A:\bas\lcdriver",A 'Save file on A drive
7 SAVE "B:\bas\lcdriver",A 'Save file on B drive
8 END
9 'Delete lines 1 - 9 & 15 - 18 for Q-Basic
10 REM Driver program for Oatley Electronics single line LC Display
11 'driven from the parallel port of a PC
15 REM run 2 will print listing on printer
16 REM run 5 will save program to drive C
17 REM run 6 will save program to drive A
18 REM run 7 will save program to drive B
20 GOSUB 1000 'Initialise software routines
30 GOSUB 2000 'Initialise display
40 GOSUB 3000 'Write data to display
50 GOSUB 6000 'Scroll message back & forth
60 GOSUB 7000 'Scroll message to left & wrap
70 GOSUB 8000 'Create your own character
999 CLS: SYSTEM
1000 '***********************
1010 'Initialisation routine.
1020 '***********************
1030 KEY OFF: CLS: DEFINT A,B,S: DEFSTR D,K
1035 'A,B,S integers, D,K are strings, rest single precision
1040 DEF FNCEOL$ = STRING$(79 - POS(Q)," ")
1050 DEF FNCENTRE$(M$) = SPACE$((78-LEN(M$))/2) + M$
1400 PORTA = &H378 'This is LPT1, use &H278 for LPT2
1410 PORTC = PORTA + 2 'Define Port C. Port B is not used
1420 COMMAND = 0: CHR = 4: STH = 0: STL = 1 'Define function & STrobe
1999 RETURN
2000 '*******************
2010 'Initialise display.
2020 '*******************
2030 FUNCT = COMMAND: OUT PORTA,0 'Define RS & set LCD inputs low
2040 GOSUB 4040 'clock RS line low
2050 OUT PORTA,48: GOSUB 4000
2060 T = TIMER: WHILE T + .03 > TIMER: WEND 'wait 30ms
2070 GOSUB 4000
2080 T = TIMER: WHILE T + .01 > TIMER: WEND 'wait 10ms
2090 GOSUB 4000
2100 OUT PORTA,60: GOSUB 4000 '16 character display
2110 OUT PORTA,14: GOSUB 4000 'display & cursor ON, UNDERLINE cursor
2120 OUT PORTA,1: GOSUB 4000 'clear home
2130 T = TIMER: WHILE T + .006 > TIMER: WEND 'clear home can take 5ms
2999 RETURN
3000 '*******************
3010 'Write data to Port.
3020 '*******************
3030 FUNCT = CHR 'set register select line high
3040 GOSUB 4040 'clock RS line high
3050 DAT = "Silicon Chip is a great magazine."
3060 FOR A = 1 TO LEN(DAT): TOWRITE = ASC(MID$(DAT,A,1))
3070 OUT PORTA,TOWRITE
3080 GOSUB 4000 'Clock full message into LCD from left hand edge
3090 NEXT
3100 GOSUB 5000 'locate cursor at 64 decimal
3110 FOR A = 9 TO LEN(DAT): TOWRITE = ASC(MID$(DAT,A,1)) 'write nessage
3120 OUT PORTA,TOWRITE 'starting at position 9 i.e. "C" for correct scroll
3130 GOSUB 4000 'Clock data into LCD
3140 NEXT
3999 RETURN
4000 '**********
4010 'Clock LCD.
4020 '**********
4030 OUT PORTC,FUNCT OR STL 'Set R/S line & take strobe low
4040 OUT PORTC,FUNCT OR STH 'Set R/S line, take strobe high.
4999 RETURN
5000 '***************************
5010 'Shift cursor to Position 9.
5020 '***************************
5030 FUNCT = COMMAND: OUT PORTC,FUNCT OR STH 'set command mode
5040 OUT PORTA,64: GOSUB 4000 'Set CG to 9
5050 OUT PORTA,192: GOSUB 4000 'Set DD to 9
5060 FUNCT = CHR: OUT PORTC,FUNCT OR STH 'restore character function
5999 RETURN
6000 '************************
6010 'Scroll message to & fro.
6020 '************************
6030 FUNCT = COMMAND: OUT PORTC,FUNCT OR STH 'set command mode
6040 LOCATE 25,1: PRINT FNCENTRE$("Press a key to end this demonstration.");
6050 OUT PORTA,24 'shift data left
6060 FOR A = 1 TO LEN(DAT) - 1: GOSUB 4000
6070 K = INKEY$: IF K > "" THEN 6990
6080 T = TIMER: WHILE T + .5> TIMER: WEND 'wait 0.5 seconds
6090 NEXT
6100 OUT PORTA,28 'shift data right
6110 FOR A = 1 TO LEN(DAT) - 1: GOSUB 4000
6120 K = INKEY$: IF K > "" THEN 6990
6130 T = TIMER: WHILE T + .5> TIMER: WEND
6140 NEXT
6150 GOTO 6050
6990 LOCATE 25,1: PRINT FNCEOL$;: LOCATE 1,1
6999 RETURN
7000 '***********************************
7010 'Scroll message to left continuously.
7020 '************************************
7030 FUNCT = COMMAND: OUT PORTC,FUNCT OR STH 'set command mode
7040 LOCATE 25,1: PRINT FNCENTRE$("Press a key to end this demonstration.");
7050 OUT PORTA,24 'shift data left
7060 FOR A = 1 TO LEN(DAT) * 32: GOSUB 4000
7070 K = INKEY$: IF K > "" THEN 7990
7080 T = TIMER: WHILE T + .5> TIMER: WEND
7090 NEXT
7990 LOCATE 25,1: PRINT FNCEOL$;: LOCATE 1,1
7999 RETURN
8000 '**************************
8010 'Create your own character.
8020 '**************************
8030 '000  01110 decimal 14  The 1's represent pixels that will
8040 '000  11011 decimal 27  be written (black)
8050 '000  00000 decimal 0  The 0's will appear clear
8060 '000  00100 decimal 4  so the character will have the shape
8070 '000  10101 decimal 21  of the 1's i.e. a crude smiley face
8080 '000  01010 decimal 10
8090 '000  00100 decimal 4
8100 '000  00000 decimal 0
8110 FUNCT = COMMAND: OUT PORTC,FUNCT OR STH 'set command mode
8120 OUT PORTA,1: GOSUB 4000 'clear home
8130 T = TIMER: WHILE T + .006 > TIMER: WEND 'clear home can take 5ms
8140 OUT PORTA,64: GOSUB 4000 'set RAM address 01000000
8150 FUNCT = CHR: GOSUB 4040 'set character mode
8160 OUT PORTA,14: GOSUB 4000 'start sending your character
8170 OUT PORTA,27: GOSUB 4000
8180 OUT PORTA,0: GOSUB 4000
8190 OUT PORTA,4: GOSUB 4000
8200 OUT PORTA,21: GOSUB 4000
8210 OUT PORTA,10: GOSUB 4000
8220 OUT PORTA,4: GOSUB 4000
8230 OUT PORTA,0: GOSUB 4000 'after the 8th bit
8240 FUNCT = COMMAND: GOSUB 4040 'change the RS line
8250 OUT PORTA,1: GOSUB 4000 'and clear/home the display
8260 T = TIMER: WHILE T + .006 > TIMER: WEND 'clear home can take 5ms
8270 FUNCT = CHR: GOSUB 4040 'revert to character mode
8280 OUT PORTA,0: GOSUB 4000 'and load our character stored at location 0
8290 FOR B = 1 TO 7:GOSUB 4000: NEXT 'then write it to the next 7 locations
8999 RETURN
